Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QDoubleSpinBox

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QObject
                  com.trolltech.qt.gui.QWidget
                      com.trolltech.qt.gui.QAbstractSpinBox
                          com.trolltech.qt.gui.QDoubleSpinBox

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

    public class QDoubleSpinBox

extends QAbstractSpinBox

The `QDoubleSpinBox` class provides a spin box widget that takes doubles.

`QDoubleSpinBox` allows the user to choose a value by clicking the up and down buttons or by pressing Up or Down on the keyboard to increase or decrease the value currently displayed. The user can also type the value in manually. The spin box supports double values but can be extended to use different strings with `validate`, `textFromValue` and `valueFromText`.

Every time the value changes `QDoubleSpinBox` emits the `valueChanged` signal. The current value can be fetched with `value` and set with `setValue`.

Note: `QDoubleSpinBox` will round numbers so they can be displayed with the current precision. In a `QDoubleSpinBox` with decimals set to 2, calling `setValue`(2.555) will cause `value` to return 2.56.

Clicking the up and down buttons or using the keyboard accelerator's Up and Down arrows will increase or decrease the current value in steps of size `singleStep`. If you want to change this behavior you can reimplement the virtual function `stepBy`. The minimum and maximum value and the step size can be set using one of the constructors, and can be changed later with `setMinimum`, `setMaximum` and `setSingleStep`. The spinbox has a default precision of 2 decimal places but this can be changed using `setDecimals`.

Most spin boxes are directional, but `QDoubleSpinBox` can also operate as a circular spin box, i.e. if the range is 0.0-99.9 and the current value is 99.9, clicking "up" will give 0 if `wrapping` is set to true. Use `setWrapping` if you want circular behavior.

The displayed value can be prepended and appended with arbitrary strings indicating, for example, currency or the unit of measurement. See `setPrefix` and `setSuffix`. The text in the spin box is retrieved with `text` (which includes any `prefix` and `suffix`), or with `cleanText` (which has no `prefix`, no `suffix` and no leading or trailing whitespace).

It is often desirable to give the user a special (often default) choice in addition to the range of numeric values. See `setSpecialValueText` for how to do this with `QDoubleSpinBox`.

See Also:
  `QSpinBox`, `QDateTimeEdit`, `QSlider`, Spin Boxes Example

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QAbstractSpinBox
`QAbstractSpinBox.ButtonSymbols, QAbstractSpinBox.CorrectionMode, QAbstractSpinBox.StepEnabled, QAbstractSpinBox.StepEnabledFlag`

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Field Summary
`QSignalEmitter.Signal1<java.lang.Double>` | `valueChanged` This signal is emitted whenever the spin box's value is changed.
`QSignalEmitter.Signal1<java.lang.String>` | `valueStringChanged` The new value is passed literally in `arg__1` with no `prefix` or `suffix`.

Fields inherited from class com.trolltech.qt.gui.QAbstractSpinBox
`editingFinished`

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Constructor Summary
`QDoubleSpinBox()` Equivalent to `QDoubleSpinBox`(0).
`QDoubleSpinBox(QWidget parent)` Constructs a spin box with 0.0 as minimum value and 99.99 as maximum value, a step value of 1.0 and a precision of 2 decimal places.

Method Summary
`java.lang.String` | `cleanText()` Returns the text of the spin box excluding any prefix, suffix, or leading or trailing whitespace..
`int` | `decimals()` Returns the precision of the spin box, in decimals.
`java.lang.String` | `fixup(java.lang.String str)` This function is reimplemented for internal reasons.
`static QDoubleSpinBox` | `fromNativePointer(QNativePointer nativePointer)` This function returns the QDoubleSpinBox instance pointed to by nativePointer
`double` | `maximum()` Returns the maximum value of the spin box.
`double` | `minimum()` Returns the minimum value of the spin box.
`java.lang.String` | `prefix()` Returns the spin box's prefix.
`void` | `setDecimals(int prec)` Sets the precision of the spin box, in decimals to `prec`.
`void` | `setMaximum(double max)` Sets the maximum value of the spin box to `max`.
`void` | `setMinimum(double min)` Sets the minimum value of the spin box to `min`.
`void` | `setPrefix(java.lang.String prefix)` Sets the spin box's prefix to `prefix`.
`void` | `setRange(double min, double max)` Convenience function to set the `min` and `max` values with a single function call.
`void` | `setSingleStep(double val)` Sets the step value to `val`.
`void` | `setSuffix(java.lang.String suffix)` Sets the suffix of the spin box to `suffix`.
`void` | `setValue(double val)` Sets the value of the spin box to `val`.
`double` | `singleStep()` Returns the step value.
`java.lang.String` | `suffix()` Returns the suffix of the spin box.
`java.lang.String` | `textFromValue(double val)` This virtual function is used by the spin box whenever it needs to display the given `val`.
`QValidator.State` | `validate(QValidator.QValidationData input)` Equivalent to validate(`input`, ).
`double` | `value()` Returns the value of the spin box.
`double` | `valueFromText(java.lang.String text)` This virtual function is used by the spin box whenever it needs to interpret `text` entered by the user as a value.

Methods inherited from class com.trolltech.qt.gui.QAbstractSpinBox
`alignment, buttonSymbols, changeEvent, clear, closeEvent, contextMenuEvent, correctionMode, event, focusInEvent, focusOutEvent, hasAcceptableInput, hasFrame, hideEvent, initStyleOption, interpretText, isAccelerated, isReadOnly, keyboardTracking, keyPressEvent, keyReleaseEvent, lineEdit, minimumSizeHint, mouseMoveEvent, mousePressEvent, mouseReleaseEvent, paintEvent, resizeEvent, selectAll, setAccelerated, setAlignment, setAlignment, setButtonSymbols, setCorrectionMode, setFrame, setKeyboardTracking, setLineEdit, setReadOnly, setSpecialValueText, setWrapping, showEvent, sizeHint, specialValueText, stepBy, stepDown, stepEnabled, stepUp, text, timerEvent, wheelEvent, wrapping`

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, contentsRect, contextMenuPolicy, createWinId, cursor, depth, destroy, destroy, destroy, devType, dragEnterEvent, dragLeaveEvent, dragMoveEvent, dropEvent, ensurePolished, enterEvent, focusNextChild, focusNextPrevChild, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, inputContext, inputMethodEvent, inputMethodQuery, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isLeftToRight, isMaximized, isMinimized, isModal, isRightToLeft, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumWidth, mouseDoubleClickEvent, mouseGrabber, move, move, moveEvent, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, overrideWindowState, overrideWindowState, paintEngine, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, width, widthMM, window, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`blockSignals, childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, property, removeEventFilter, setObjectName, setParent, setProperty, signalsBlocked, startTimer, thread`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`disconnect, disconnect, signalSender`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### valueStringChanged

    public final QSignalEmitter.Signal1<java.lang.String> valueStringChanged

  The new value is passed literally in `arg__1` with no `prefix` or `suffix`.

  Compatible Slot Signatures:
    `void mySlot(java.lang.String arg__1)`
    `void mySlot()`

### valueChanged

    public final QSignalEmitter.Signal1<java.lang.Double> valueChanged

  This signal is emitted whenever the spin box's value is changed. The new value is passed in `arg__1`.

  Compatible Slot Signatures:
    `void mySlot(double arg__1)`
    `void mySlot()`

Constructor Detail

### QDoubleSpinBox

    public QDoubleSpinBox()

  Equivalent to `QDoubleSpinBox`(0).

### QDoubleSpinBox

    public QDoubleSpinBox(QWidget parent)

  Constructs a spin box with 0.0 as minimum value and 99.99 as maximum value, a step value of 1.0 and a precision of 2 decimal places. The value is initially set to 0.00. The spin box has the given `parent`.

  See Also:
    `setMinimum`, `setMaximum`, `setSingleStep`

Method Detail

### cleanText

    public final java.lang.String cleanText()

  Returns the text of the spin box excluding any prefix, suffix, or leading or trailing whitespace..

  See Also:
    text, `QDoubleSpinBox::prefix`, `QDoubleSpinBox::suffix`

### decimals

    public final int decimals()

  Returns the precision of the spin box, in decimals.

  Sets how many decimals the spinbox will use for displaying and interpreting doubles.

  Warning: The results might not be reliable with very high values for `decimals`.

  Note: The maximum, minimum and value might change as a result of changing this property.

  See Also:
    `setDecimals`

### maximum

    public final double maximum()

  Returns the maximum value of the spin box.

  When setting this property the minimum is adjusted if necessary, to ensure that the range remains valid.

  The default maximum value is 99.99.

  Note: The maximum value will be rounded to match the decimals property.

  See Also:
    `setMaximum`, decimals, `setRange`

### minimum

    public final double minimum()

  Returns the minimum value of the spin box.

  When setting this property the maximum is adjusted if necessary to ensure that the range remains valid.

  The default minimum value is 0.0.

  Note: The minimum value will be rounded to match the decimals property.

  See Also:
    `setMinimum`, decimals, `setRange`, `specialValueText`

### prefix

    public final java.lang.String prefix()

  Returns the spin box's prefix.

  The prefix is prepended to the start of the displayed value. Typical use is to display a unit of measurement or a currency symbol. For example:

          spinbox->setPrefix("$");

  To turn off the prefix display, set this property to an empty string. The default is no prefix. The prefix is not displayed when `value` == `minimum` and `specialValueText` is set.

  If no prefix is set, `prefix` returns an empty string.

  See Also:
    `setPrefix`, `suffix`, `setSuffix`, `specialValueText`, `setSpecialValueText`

### setDecimals

    public final void setDecimals(int prec)

  Sets the precision of the spin box, in decimals to `prec`.

  Sets how many decimals the spinbox will use for displaying and interpreting doubles.

  Warning: The results might not be reliable with very high values for `decimals`.

  Note: The maximum, minimum and value might change as a result of changing this property.

  See Also:
    `decimals`

### setMaximum

    public final void setMaximum(double max)

  Sets the maximum value of the spin box to `max`.

  When setting this property the minimum is adjusted if necessary, to ensure that the range remains valid.

  The default maximum value is 99.99.

  Note: The maximum value will be rounded to match the decimals property.

  See Also:
    `maximum`, decimals, `setRange`

### setMinimum

    public final void setMinimum(double min)

  Sets the minimum value of the spin box to `min`.

  When setting this property the maximum is adjusted if necessary to ensure that the range remains valid.

  The default minimum value is 0.0.

  Note: The minimum value will be rounded to match the decimals property.

  See Also:
    `minimum`, decimals, `setRange`, `specialValueText`

### setPrefix

    public final void setPrefix(java.lang.String prefix)

  Sets the spin box's prefix to `prefix`.

  The prefix is prepended to the start of the displayed value. Typical use is to display a unit of measurement or a currency symbol. For example:

          spinbox->setPrefix("$");

  To turn off the prefix display, set this property to an empty string. The default is no prefix. The prefix is not displayed when `value` == `minimum` and `specialValueText` is set.

  If no prefix is set, `prefix` returns an empty string.

  See Also:
    `prefix`, `suffix`, `setSuffix`, `specialValueText`, `setSpecialValueText`

### setRange

    public final void setRange(double min,
                               double max)

  Convenience function to set the `min` and `max` values with a single function call.

  Note: The maximum and minimum values will be rounded to match the decimals property.

          setRange(minimum, maximum);

  is equivalent to:

          setMinimum(minimum);
          setMaximum(maximum);

  See Also:
    minimum, maximum

### setSingleStep

    public final void setSingleStep(double val)

  Sets the step value to `val`.

  When the user uses the arrows to change the spin box's value the value will be incremented/decremented by the amount of the `singleStep`. The default value is 1.0. Setting a `singleStep` value of less than 0 does nothing.

  See Also:
    `singleStep`

### setSuffix

    public final void setSuffix(java.lang.String suffix)

  Sets the suffix of the spin box to `suffix`.

  The suffix is appended to the end of the displayed value. Typical use is to display a unit of measurement or a currency symbol. For example:

          spinbox->setSuffix(" km");

  To turn off the suffix display, set this property to an empty string. The default is no suffix. The suffix is not displayed for the `minimum` if `specialValueText` is set.

  If no suffix is set, `suffix` returns an empty string.

  See Also:
    `suffix`, `prefix`, `setPrefix`, `specialValueText`, `setSpecialValueText`

### setValue

    public final void setValue(double val)

  Sets the value of the spin box to `val`.

  `setValue` will emit `valueChanged` if the new value is different from the old one.

  Note: The value will be rounded so it can be displayed with the current setting of decimals.

  See Also:
    `value`, decimals

### singleStep

    public final double singleStep()

  Returns the step value.

  When the user uses the arrows to change the spin box's value the value will be incremented/decremented by the amount of the `singleStep`. The default value is 1.0. Setting a `singleStep` value of less than 0 does nothing.

  See Also:
    `setSingleStep`

### suffix

    public final java.lang.String suffix()

  Returns the suffix of the spin box.

  The suffix is appended to the end of the displayed value. Typical use is to display a unit of measurement or a currency symbol. For example:

          spinbox->setSuffix(" km");

  To turn off the suffix display, set this property to an empty string. The default is no suffix. The suffix is not displayed for the `minimum` if `specialValueText` is set.

  If no suffix is set, `suffix` returns an empty string.

  See Also:
    `setSuffix`, `prefix`, `setPrefix`, `specialValueText`, `setSpecialValueText`

### value

    public final double value()

  Returns the value of the spin box.

  `setValue` will emit `valueChanged` if the new value is different from the old one.

  Note: The value will be rounded so it can be displayed with the current setting of decimals.

  See Also:
    `setValue`, decimals

### fixup

    public java.lang.String fixup(java.lang.String str)

  This function is reimplemented for internal reasons.

  Overrides:
    `fixup` in class `QAbstractSpinBox`

### textFromValue

    public java.lang.String textFromValue(double val)

  This virtual function is used by the spin box whenever it needs to display the given `val`. The default implementation returns a string containing `val` printed using QLocale().toString(`val`, QLatin1Char('f'), `decimals`) and will remove the thousand separator. Reimplementations may return anything.

  Note: `QDoubleSpinBox` does not call this function for `specialValueText` and that neither `prefix` nor `suffix` should be included in the return value.

  If you reimplement this, you may also need to reimplement `valueFromText`.

  See Also:
    `valueFromText`

### validate

    public QValidator.State validate(QValidator.QValidationData input)

  Equivalent to validate(`input`, ).

  Overrides:
    `validate` in class `QAbstractSpinBox`

### valueFromText

    public double valueFromText(java.lang.String text)

  This virtual function is used by the spin box whenever it needs to interpret `text` entered by the user as a value.

  Subclasses that need to display spin box values in a non-numeric way need to reimplement this function.

  Note: `QDoubleSpinBox` handles `specialValueText` separately; this function is only concerned with the other values.

  See Also:
    `textFromValue`, `validate`

### fromNativePointer

    public static QDoubleSpinBox fromNativePointer(QNativePointer nativePointer)

  This function returns the QDoubleSpinBox instance pointed to by nativePointer

  Parameters:
    `nativePointer` - the QNativePointer of which object should be returned.

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD